<!DOCTYPE html>
<!--[if IE 8]>
<html <?php language_attributes(); ?> class="ie8"> <![endif]-->
<!--[if !IE]><!-->
<html <?php language_attributes(); ?>> <!--<![endif]-->

<head>
	<meta charset="<?php bloginfo( 'charset' ); ?>">
	<title><?php wp_title( '|', true, 'right' ); ?><?php bloginfo( 'name' ); ?></title>
	<meta name="description" content="<?php bloginfo( 'description' ); ?>">

	<!-- Mobile Specific Meta -->
	<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">

	<!--[if lt IE 9]>
	<script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->


	<?php wp_head(); ?>
</head>
<body <?php body_class(); ?>>
<header>
	<div class="top-nav">
		<div class="container">
			<div class="col-md-6">
				<div class="top-menu">
					<ul class="list-inline">
						<?php
						$current_user = wp_get_current_user(); ?>
						<?php if ( is_user_logged_in() ): ?>
							<li><a href="<?php echo wp_logout_url( get_permalink() ); ?>"><i class="fa fa-sign-in"></i>
									<?php _e( 'تسجيل خروج', 'alpha' ); ?></a></li>
							<li><a href=" <?php echo get_edit_user_link(); ?>"><i class="fa fa-user-plus"></i> <?php _e('اهلاً','alpha'); ?>
									، <?php echo $current_user->user_login; ?></a>
							</li>
						<?php else : ?>
							<li><a href="<?php echo wp_login_url( get_permalink() ); ?>"><i class="fa fa-sign-in"></i>
									<?php _e( 'تسجيل دخول', 'alpha' ); ?></a></li>
							<li><a href=" <?php echo wp_registration_url(); ?>"><i
										class="fa fa-user-plus"></i> <?php _e( 'عضو جديد', 'alpha' ); ?></a>
							</li>
						<?php endif; ?>
						<?php if ( is_rtl() ) : ?>
							<li class="langs">
								<div class="dropdown ">
									<a class=" dropdown-toggle"  id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
										<i class="fa fa-globe"></i> اللغة العربية
									</a>

									<div class="dropdown-menu" aria-labelledby="dropdownMenuLink">
										<a class="dropdown-item" href="<?php echo site_url(); ?>?lang=en">English</a>
										<a class="dropdown-item" href="<?php echo site_url(); ?>?lang=fr">Français</a>
									</div>
								</div>
							</li>
						<?php endif; ?>
						<?php if(ICL_LANGUAGE_CODE=='en') : ?>
						<li class="langs">
							<div class="dropdown ">
								<a class=" dropdown-toggle"  id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
									<i class="fa fa-globe"></i> English
								</a>

								<div class="dropdown-menu" aria-labelledby="dropdownMenuLink">
									<a class="dropdown-item" href="<?php echo site_url(); ?>?lang=ar">العربية</a>
									<a class="dropdown-item" href="<?php echo site_url(); ?>?lang=fr">Français</a>
								</div>
							</div>
						</li>

						<?php endif; ?>
						<?php if(ICL_LANGUAGE_CODE=='fr') : ?>
							<li class="langs">
								<div class="dropdown ">
									<a class=" dropdown-toggle"  id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
										<i class="fa fa-globe"></i> Français
									</a>

									<div class="dropdown-menu" aria-labelledby="dropdownMenuLink">
										<a class="dropdown-item" href="<?php echo site_url(); ?>?lang=ar">العربية</a>
										<a class="dropdown-item" href="<?php echo site_url(); ?>?lang=en">English</a>
									</div>
								</div>
							</li>

						<?php endif; ?>
					</ul>
				</div>
			</div>
			<div class="col-md-6">

				<ul class="social list-inline pull-left">

					<li><a href="" data-toggle="modal" data-target="#myModal"><i class="fa fa-search"></i></a>
					</li>
					<?php if ( get_field( 'fb', 'options' ) ) : ?>
						<li><a href="<?php the_field( 'fb', 'options' ); ?>"><i class="fa fa-facebook"></i></a>
						</li>
					<?php endif; ?>
					<?php if ( get_field( 'tw', 'options' ) ) : ?>
						<li><a href="<?php the_field( 'tw', 'options' ); ?>"><i class="fa fa-twitter"></i></a>
						</li>
					<?php endif; ?>
					<?php if ( get_field( 'yt', 'options' ) ) : ?>
						<li><a href="<?php the_field( 'yt', 'options' ); ?>"><i class="fa fa-youtube"></i></a>
						</li>
					<?php endif; ?>
					<?php if ( get_field( 'insta', 'options' ) ) : ?>
						<li><a href="<?php the_field( 'insta', 'options' ); ?>"><i class="fa fa-instagram"></i></a>
						</li>
					<?php endif; ?>

				</ul>
			</div>
		</div>
	</div>

	<div class="container">
		<div class="row">
			<div class="col-sm-4">
				<div class="logo">
					<a href="<?php echo home_url(); ?>">
						<img src="<?php the_field( 'logo', 'options' ); ?>" alt="<?php bloginfo( 'desvription' ); ?>"
						     class="img-responsive">
					</a>
				</div>
			</div>
			<div class="col-sm-8">
				<div class="top-ad">
					<?php the_field( 'header-adv', 'options' ); ?>
				</div>
			</div>
		</div>

	</div>

	<nav class="navbar navbar-default">
		<div class="container">
			<!-- Brand and toggle get grouped for better mobile display -->
			<div class="navbar-header">
				<button type="button" class="navbar-toggle collapsed" data-toggle="collapse"
				        data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
					<span class="sr-only">Toggle navigation</span>
					<span class="icon-bar"></span>
					<span class="icon-bar"></span>
					<span class="icon-bar"></span>
				</button>
			</div>

			<!-- Collect the nav links, forms, and other content for toggling -->
			<?php
			wp_nav_menu( array(
					'menu'            => 'main-menu',
					'theme_location'  => 'main-menu',
					'depth'           => 2,
					'container'       => 'div',
					'container_class' => 'collapse navbar-collapse',
					'container_id'    => 'bs-example-navbar-collapse-1',
					'menu_class'      => 'nav navbar-nav',
					'fallback_cb'     => 'wp_bootstrap_navwalker::fallback',
					'walker'          => new wp_bootstrap_navwalker()
				)
			);
			?>

		</div><!-- /.container-fluid -->
	</nav>
</header>


<!-- Modal -->
<div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
	<div class="modal-dialog" role="document">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span
						aria-hidden="true">&times;</span></button>
				<h4 class="modal-title" id="myModalLabel"><?php _e( 'بحث', 'alpha' ); ?></h4>
			</div>
			<div class="modal-body">
				<?php get_search_form(); ?>
			</div>

		</div>
	</div>
</div>

